function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function util_check_is_maps_page(){
     //检测当前是否maps页面
    chrome.tabs.getSelected(null, function (tab) {
        var current_url =  tab.url;
        if(current_url){
            if(current_url.indexOf('map')==-1){
                   chrome.tabs.create({ url: "https://map.baidu.com/" });
            }
        }else{
            chrome.tabs.create({ url: "https://map.baidu.com/" });
        }
    });
}

function extract_get_catalog_products_num(){
    //
        //$('#message-info').html('处理中...')
        console.log('extract_get_catalog_products_num');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract_get_catalog_products_num',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content extract_get_catalog_products_num')
                console.log(res)
                var catalog_products_num = 0;
                if(res){
                    catalog_products_num = res;
                }
                $('.catalog-products-num').html(catalog_products_num);
            })
        })
}

extract_get_catalog_products_num();

function get_expire(){
    // popup ---> content
                      /*  chrome.tabs.query({
                            active: true,
                            currentWindow: true
                        }, (tabs) => {
                            let message = {
                                action: 'set_expire',
                                date: ''
                            }
                            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                                console.log('popup=>content set_expire')
                                console.log(res)
                                expire_data = res[0];
                                expire_date = expire_data['expire'];
                                expire_date = expire_date.replace('T00:00:00.000Z','');
                                $('#expire_date').html(expire_date);
                                //$('.catalog-products-num').html('0');
                                //$('#message-info').html('');
                                //
                                //$('#message-info').html('完成,提取:'+res.length);
                                //$('#message-info').html('完成')
                            })
                        })*/

        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'get_expire',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content get_expire')
                console.log(res)
                expire_data = res[0];
                expire_date = expire_data['expire'];
                expire_date = expire_date.replace('T00:00:00.000Z','');
                $('#expire_date').html(expire_date);
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
            })
        })
}

get_expire();

function extract_catalog_products_export_clean(){
    $('#extract-catalog-products-export-clean').click(function (){
        util_check_is_maps_page();
         //
        $('#message-info').html('<span style="font-size: 12px;">提取需要花费时间，请保持界面不动,处理中...</span>')
        console.log('extract-catalog-products-url');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract-catalog-products-export-clean',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content extract-catalog-products-export-clean')
                console.log(res)
                //
                expire_data = res['expire'][0];
                expire_date = expire_data['expire'];
                expire_date = expire_date.replace('T00:00:00.000Z','');
                if (util_check_expire(expire_date)) {
                    $('.jihuo').show();
                    $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                    $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                    return;
                }
                //
                //$('.catalog-products-num').html('0');
                //
                exportToExcel(res['shangjia_infos'], res['file_name'], "Sheet1");
                //
                $('#message-info').html('');
                //
                //$('#message-info').html('完成,提取:'+res.length);
                //$('#message-info').html('完成')
            })
        })
        //
    });
}

extract_catalog_products_export_clean();

function extract_catalog_products_clean(){
    $('#extract-catalog-products-clean').click(function (){
        util_check_is_maps_page();
        $('#message-info').html('处理中...')
        console.log('extract_catalog_products_clean');
        // popup ---> content
        chrome.tabs.query({
            active: true,
            currentWindow: true
        }, (tabs) => {
            let message = {
                action: 'extract_catalog_products_clean',
                info: ''
            }
            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                console.log('popup=>content')
                console.log(res)
                $('.catalog-products-num').html('0');
                $('#message-info').html('');
                //
                //$('#message-info').html('完成,提取:'+res.length);
                //$('#message-info').html('完成')
            })
        })
        //
    });
}

extract_catalog_products_clean();
//
function jihuo(){
    $('#jihuo_btn').click(function (){
        util_check_is_maps_page();
        var jihuo_text = $('#jihuo_text').val();
        jihuo_text = jihuo_text.trim();
        $('#message-info').html('');
        if(jihuo_text==''){
            $('#message-info').html('<span style="color:red;">请输入激活码</span>');
            return;
        }
        //
        // other then GET
        let options = {
            method: 'GET',
            headers: {
                'Content-Type':'application/json;charset=utf-8'
            },
            //body: JSON.stringify(res)
        }
        // Fake api for making post requests
        let fetchRes = fetch( "https://api.gycharm.com/v1/plugin-chkpro/" + jihuo_text);
        fetchRes.then(res =>
            res.json()).then(d => {
                console.log('post response:');
                console.log(d);
                console.log(d['VAL']);
                //
                if (d['VAL'] === "NO_KEY") {
                    $('#message-info').html('<span style="color:red;">激活码不存在!</span>');
                }else if(d['VAL'] == 'HAS_BOUND'){
                    $('#message-info').html('<span style="color:red;">激活码已使用过!</span>');
                }else {
                    var expire_date = d['VAL'];
                    if (util_check_expire(expire_date) == false) {

                        // popup ---> content
                        chrome.tabs.query({
                            active: true,
                            currentWindow: true
                        }, (tabs) => {
                            let message = {
                                action: 'set_expire',
                                date: expire_date
                            }
                            chrome.tabs.sendMessage(tabs[0].id, message, res => {
                                console.log('popup=>content set_expire')
                                console.log(res)
                                expire_data = res[0];
                                expire_date = expire_data['expire'];
                                expire_date = expire_date.replace('T00:00:00.000Z','');
                                $('#expire_date').html(expire_date);
                                $('.jihuo').hide();
                                $('#message-info').html('');
                            })
                        })
                      //
                    }else{
                        $('.jihuo').show();
                        $('#expire_date').html("<span style='color:red;'>已过期或未激活</span>");
                        $('#message-info').html("<span style='color:red;'>已过期或未激活，</span><a href='https://www.gycharm.com/user/order-plugin' target='_blank'>续费或者购买后，</a> <span style='color:red;'>在下面输入框激活！</span>");
                        return;
                    }
                }
                //
            })
                //
    });
}
jihuo();
//从content接收信息
chrome.runtime.onMessage.addListener((req, send, sendRes) => {
    console.log("收到info:", req.info)
    console.log("收到action:", req.action)
    console.log("收到tbm_map_urls:", req.nums)

    if(req.action == 'update-shangjia-num'){
        var catalog_products_num = req.nums;
        $('.catalog-products-num').html(catalog_products_num);
    }

    sendRes("popup已经收到")

  })
//
//
document.getElementById("opnGmaps").addEventListener('click', function () {
  chrome.tabs.create({ url: "https://map.baidu.com/" });
})
//
//get columns
function getColumns(paramData){

	var header = [];
	$.each(paramData[0], function (key, value) {
		//console.log(key + '==' + value);
		var obj = {}
		obj["headertext"] = key;
		obj["datatype"] = "string";
		obj["datafield"] = key;
		header.push(obj);
	});
	return header;
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}